{***********************************************************************
*  TKaotiK Ball version 1.0                                            *
*                                                                      *
*    Copyright  1997, 1998  Karlos, Inc. All Rights Reserved.         *
*    Developed By: Karlos Jorge Pinto                                  *
*    E-MAIL: Karlospinto@hotmail.com                                   *
*    Delphi Super Site o---> Delphi@pt <---o:                          *
*    http://www.terravista.pt/bilene/1412 ---> In English/Portuguese   *
*                                                                      *
************************************************************************
*  IRC: #portugal - Undernet. Nick: kArLoS.                            *
*  This is shareware, if you want to use in your projects you have to  *
*  pay *only* $3, for registrate this component. To do this please read*
*  the Register.txt, for more details.                   Made:  1/98   *
***********************************************************************}

unit KaotiK;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DsgnIntf;

type
  TKaotiKBallx = class(TGraphicControl)
  private
    FAbout: string;
    fTimer     : TTimer;
    fHorStep,
    fVerStep   : integer;
    fContinuous: boolean;
  protected
    procedure SetContinuous(Value : boolean);
    procedure Paint; override;
  public
    procedure ShowAbout;Virtual;
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; Override;
    procedure   MoveBall(Sender: TObject);
  published
    property About: string read FAbout write FAbout stored False;
    property Continuous : boolean read fContinuous write SetContinuous default True;
  end;

procedure Register;

implementation


type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}


procedure TAboutProperty.Edit;
{call the 'About' dialog window when clicking on in the Object Inspector}
begin
  TKaotiKBallx (GetComponent(0)).ShowAbout;
end;
function TAboutProperty.GetAttributes: TPropertyAttributes;
{set up to display a string in the Object Inspector}
begin
  GetAttributes := [paDialog, paReadOnly];
end;
function TAboutProperty.GetValue: String;
{set string to appear in the Object Inspector}
begin
  GetValue := '(About KaotiK Ball v.1.0)';
end;
procedure TKaotiKBallx.ShowAbout;
var
	msg: string;
const
  cr = chr(13);
begin
  msg := '  --> The KaotiK Ball a cool Moving Ball. Version: 1.0 <--' + cr;
  msg := msg + 'TKaotiKBall:' + ' a 16/32-Bit Component for Delphi' + cr;
  {$IFDEF WIN32}
  msg := msg + '(This is the 32 bit version)' + cr + cr;
  {$ELSE}
  msg := msg + '(This is the 16 bit version)' + cr + cr;
  {$ENDIF}
  msg := msg + 'Copyright  1997/98 Karlos Inc.' + cr;
  msg := msg + 'Made By: Karlos Pinto' + cr;
  msg := msg + '*****************************************************************' + cr;
  msg := msg + 'Delphi@pt site: http://www.terravista.pt/bilene/1412' + cr;
  msg := msg + 'E-Mail: Karlospinto@hotmail.com' + cr;
  msg := msg + '*****************************************************************' + cr;
  msg := msg + 'This Component is SHAREWARE, please read Register.TXT.' + cr;
  msg := msg + '        ...---**** KARLOS PINTO Inc.****---...' + cr;
  msg := msg + '  IRC: #portugal - Undernet, Nick: kArLoS :)' + cr;
  msg := msg + 'If you want more comp., apz., games please send a' + cr;
  msg := msg + 'E-Mail to me, or go to the IRC, Wed 10.30 GMT. :-)' + cr;

    MessageDlg(msg,mtInformation,[MBOK],0);
end;

{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}

  procedure Register;
  begin
    RegisterComponents( 'Karlos Inc.', [ TKaotiKBallx ] );
    {register the 'About' property editor}
     RegisterPropertyEditor(TypeInfo(String), TKaotiKBallx, 'About',
     TAboutProperty);

  end;
{########################################################################}
{########################################################################}
{########################################################################}
{########################################################################}
{########################################################################}




constructor TKaotiKBallx.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Left   := 100; { Initial location and size }
  Top    := 100;
  Height := 20;
  Width  := 20;
  fHorStep := 1+random(10);
  fVerStep := 1+random(10);
  fContinuous  := False;
  SetContinuous(True);
  {...}
end;

destructor TKaotiKBallx.Destroy;
begin
  {...}
  if fContinuous then fTimer.Free;
  inherited Destroy;
end;

procedure TKaotiKBallx.MoveBall(Sender: TObject);
begin
   if fHorStep < 0 then
      if (Left-fHorStep > 0) then
         SetBounds(Left+fHorStep, Top, Width, Height)
      else fHorStep := (1+random(10))
   else
      if (Left+Width+fHorStep <= Parent.ClientWidth) then
         SetBounds(Left+fHorStep, Top, Width, Height)
      else fHorStep   := -(1+random(10));

   if fVerStep < 0 then
      if (Top-fVerStep > 0) then
         SetBounds(Left, Top+fVerStep, Width, Height)
      else fVerStep := (1+random(10))
   else
      if (Top+Height+fVerStep <= Parent.ClientHeight) then
         SetBounds(Left, Top+fVerStep, Width, Height)
      else fVerStep   := -(1+random(10));
end;

procedure TKaotiKBallx.SetContinuous(Value : boolean);
begin
  if fContinuous=Value then exit;
  fContinuous := Value;
  if fContinuous then begin
     fTimer := TTimer.Create(Self);
     fTimer.Interval := 1;
     fTimer.OnTimer  := MoveBall;
     fTimer.Enabled  := True;
  end else
     fTimer.Free;
end;{}

procedure TKaotiKBallx.Paint;
begin
  with Canvas do begin
    Pen.Color := clBlue;
    Pen.Width := 3;
    Brush.Color := clLime;
    Brush.Style := bssolid;
    Ellipse(0,0,Width,Height);
  end;
end;{}

end.
